#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

using ll = long long;
#define int ll

namespace std{
    template<typename T,typename U>
    struct hash<pair<T,U>> {
        size_t operator () (const pair<T,U> & a) const {
            return std::hash<T>()(a.first) ^ (std::hash<U>()(a.second) << 10);
        }
    };
}


ll pascal (ll n, ll k) {
    static unordered_map<pair<ll, ll>, ll> triangle;
    pair<ll, ll> key = { n, k };

    if (n == 0 || k == 0 || k == n) return 1;

    if (triangle.count(key)) {
        return triangle[key];
    }

    ll a = pascal(n - 1, k - 1);
    ll b = pascal(n - 1, k);
    ll newVal = a + b;

    if (a < 0 || b < 0 || a + b < 0) {
        newVal = -1;
    }

    triangle[key] = newVal;
    return newVal;
}

signed main() {

    string lmao;
    cin >> lmao;
    char last = '#';
    ll count_plus = 0;
    ll count_minus = 0;
    for (char item: lmao){
        if(item == last){
            if(item== '+'){
                count_plus++;
            } else {
                count_minus++;
            }
        }
        last = item;
    }
    cout << max(count_minus,count_plus);
    return 0;
}
